
$:.unshift(File.join(File.dirname(__FILE__), 'ext'))
$:.unshift(File.join(File.dirname(__FILE__), 'lib'))

require 'curb'
require 'digest'

# API Request URL
$API_URL = 'https://api-test.prizmmpay.com/sale'

# Current Unix Timestamp
$UNIX_TIMESTAMP = "" + Time.now.to_i.to_s

# HTTP Session ID, request.session_options[:id]
$SESSION_ID = $UNIX_TIMESTAMP

# Merchant Reference No., generally this is Order ID
$ORDER_ID = $UNIX_TIMESTAMP

# Merchant ID provided from Prizm Pay
$MERCHANT_ID = 'YOUR_MID'

# Merchant Secret Key can be found in Prizm Pay Merchant Panel
$SECRET_KEY = 'YOUR_KEY'

# Request Data in JSON
$JSON_DATA = '{
 "item":[
 {
 "name":"Orange",
 "quantity":"1",
 "unitPrice":"1"
 },
 {
 "name":"Apple",
 "quantity":"2",
 "unitPrice":"3"
 }
 ],
 "billTo":{
 "firstName":"John",
 "lastName":"Doe",
 "email":"john.doe@prizmpay-test.com",
 "phoneNumber":"650-965-6000",
 "street1":"1295 Charleston Rd.",
 "street2":"",
 "city":"Mountain View",
 "state":"CA",
 "country":"US",
 "postalCode":"94043"
 },
 "shipTo":{
 "firstName":"John",
 "lastName":"Doe",
 "email":"john.doe@prizmpay-test.com",
 "phoneNumber":"650-965-6000",
 "street1":"1295 Charleston Rd.",
 "street2":"",
 "city":"Mountain View",
 "state":"CA",
 "country":"US",
 "postalCode":"94043"
 },
 "cardHolder":{
 "firstName":"John",
 "lastName":"Doe",
 "email":"john.doe@prizmpay-test.com",
 "phoneNumber":"650-965-6000",
 "street1":"1295 Charleston Rd.",
 "street2":"",
 "city":"Mountain View",
 "state":"CA",
 "country":"US",
 "postalCode":"94043"
 },
 "card":{
 "cardType":"visa",
 "fullName":"John Doe",
 "accountNumber":"4111111111111111",
 "cvNumber":"413",
 "expirationMonth":"06",
 "expirationYear":"2016"
 },
 "deviceFingerprintID":"' + $MERCHANT_ID + '_' + $ORDER_ID + '_' + $SESSION_ID + '",
 "merchantID":"' + $MERCHANT_ID + '",
 "merchantReferenceCode":"' + $ORDER_ID + '",
 "purchaseTotals":{
 "grandTotalAmount":"7",
 "currency":"USD"
 },
 "merchantInvoiceID":"' + $ORDER_ID + '"
}'

# Secret Hash generated by Request Data
$API_HASH = Digest::SHA256.hexdigest($SECRET_KEY + $UNIX_TIMESTAMP + $MERCHANT_ID + $JSON_DATA)


fields = [
	Curl::PostField.content('data', $JSON_DATA),
]

c = Curl::Easy.http_post($API_URL, *fields) do |curl|
  curl.headers["API_VERSION"] = "100"
  curl.headers["API_MID"] = $MERCHANT_ID
  curl.headers["API_TIME"] = $UNIX_TIMESTAMP
  curl.headers["API_HASH"] = $API_HASH
  curl.verbose = true
  curl.follow_location = true
  curl.enable_cookies = true
end

puts "FINISHED: HTTP #{c.response_code}"
puts c.body_str
